unit main;

interface

uses
  Windows, Messages, SysUtils, Graphics, Forms,  Jpeg, ShellAPI,
  ComCtrls, ShellCtrls, StdCtrls, Classes, Controls, Spin, IniFiles,
  Menus, bmp2Tiff, registry;

const
  WM_NOTIFYTRAYICON = WM_USER + 1;
  vers = 'v0.6';

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    Button2: TButton;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    GroupBox3: TGroupBox;
    ScrollBar1: TScrollBar;
    Label2: TLabel;
    GroupBox4: TGroupBox;
    ComboBox1: TComboBox;
    GroupBox5: TGroupBox;
    Edit3: TEdit;
    ShellTreeView1: TShellTreeView;
    SpinEdit1: TSpinEdit;
    Button1: TButton;
    Button4: TButton;
    GroupBox6: TGroupBox;
    TrackBar1: TTrackBar;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    Button3: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    GroupBox7: TGroupBox;
    DelayedShoot: TCheckBox;
    Edit2: TEdit;
    Label3: TLabel;
    GroupBox8: TGroupBox;
    Label4: TLabel;
    Edit4: TEdit;
    Label5: TLabel;
    CheckBox1: TCheckBox;
    GroupBox9: TGroupBox;
    CaptureCursor: TCheckBox;
    Mask: TComboBox;
    Button9: TButton;
    GroupBox10: TGroupBox;
    AutoRun: TCheckBox;
    Minimazed: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure AutoRunClick(Sender: TObject);
  private
    { Private declarations }
    hk1, hk2, hk3, hk4: Integer; {  . }
    procedure WMHotkey(var msg: TWMHotkey ); message WM_HOTKEY;
    procedure WMTRAYICONNOTIFY(var Msg: TMessage); message WM_NOTIFYTRAYICON;
  public
    { Public declarations }
    function FNBM:string;
    procedure SaveSettings;
    procedure LoadSettings;
    procedure ShootScreen;
    procedure ShootWindow;
    procedure TimeredCapture;
    function GetCursorInf: TCursorInfo;
  end;

var
  MainForm: TMainForm;
  TimerCapture:Boolean;

implementation

uses aboutUnit;

{$R *.dfm}

procedure Delay(ms: longint);
var
  TheTime: LongInt;
begin
  TheTime := GetTickCount + ms;
  while GetTickCount < TheTime do
    Application.ProcessMessages;
end;

procedure TMainForm.WMTRAYICONNOTIFY(var Msg: TMessage);
var
  P:TPoint;
begin
  case Msg.LParam of
    WM_LBUTTONDOWN:
      begin
        Application.Restore;
        ShowWindow(Application.Handle, sw_Hide);
        SetForegroundWindow(Application.Handle);
      end;
    WM_RBUTTONDOWN:
      begin
        GetCursorPos(P);
        PopupMenu1.Popup(P.X,P.Y);
      end;
  end;
end;

function TMainForm.FNBM:string;
var
  ts:string;
  i,cnt:integer;
begin
  i:=pos('#',Mask.Text);
  cnt:=0;
  if i<>0 then
    begin
      cnt:=1;
      while Copy(Mask.Text,i+1,1) = '#' do
        begin
          i:=i+1;
          cnt:=cnt+1;
        end;
//      ShowMessage(inttostr(cnt));
    end;
  if cnt <> 0 then
    begin
      ts:=SpinEdit1.Text;
      while Length(ts) < cnt do ts:='0'+ts;
//      ShowMessage('out:'+ts);
    end;
//  ShowMessage(ShellTreeView1.Path+'\'+Copy(Edit1.Text,1,pos('#',Edit1.Text)-1)+ts+Copy(Edit1.Text,i+1,length(Edit1.Text)-i));
  Result:=ShellTreeView1.Path+'\'+Copy(Mask.Text,1,pos('#',Mask.Text)-1)+ts+Copy(Mask.Text,i+1,length(Mask.Text)-i);
end;

procedure TMainForm.SaveSettings;
var
  inif:TIniFile;
  i:word;
begin
  inif:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'\config.ini');
  inif.WriteString('WindowPosition','X',inttostr(MainForm.Left));
  inif.WriteString('WindowPosition','Y',inttostr(MainForm.Top));
  inif.WriteString('WindowPosition','Alpha',inttostr(MainForm.AlphaBlendValue));
  if CheckBox1.Checked then
    inif.WriteString('WindowPosition','UseAlpha','1')
  else
    inif.WriteString('WindowPosition','UseAlpha','0');
  if Minimazed.Checked then
    inif.WriteString('WindowPosition','StartMinimazed','1')
  else
    inif.WriteString('WindowPosition','StartMinimazed','0');
  inif.WriteString('FileName','Path',ShellTreeView1.Path);
  inif.WriteString('FileName','Count',SpinEdit1.Text);
  inif.WriteString('Format','Type',inttostr(ComboBox1.ItemIndex));
  inif.WriteString('Format','JPEG_Quality',inttostr(ScrollBar1.Position));
  if DelayedShoot.Checked then
    inif.WriteString('ShootSettings','UseDelay','1')
  else
    inif.WriteString('ShootSettings','UseDelay','0');
  if CaptureCursor.Checked then
    inif.WriteString('ShootSettings','CaptureCursor','1')
  else
    inif.WriteString('ShootSettings','CaptureCursor','0');
  inif.WriteString('ShootSettings','Delay',Edit2.Text);
  inif.WriteString('ShootSettings','Timer',Edit4.Text);

  inif.WriteString('Masks','Last',Mask.Text);
  if Mask.Items.Count<>0 then 
  for i:=0 to Mask.Items.Count-1 do
    begin
      inif.WriteString('Masks','Mask'+IntToStr(i),Mask.Items[i]);
    end;

  inif.Free;
end;

procedure TMainForm.LoadSettings;
var
  inif:TIniFile;
  Tmp:TStrings;
  I:integer;
  Reg: TRegistry;
begin
  if FileExists(ExtractFilePath(Application.ExeName)+'\config.ini') then
    begin
      inif:=TIniFile.Create(ExtractFilePath(Application.ExeName)+'\config.ini');
      MainForm.Left:=strtoint(inif.ReadString('WindowPosition','X','0'));
      MainForm.Top:=strtoint(inif.ReadString('WindowPosition','Y','0'));
      if inif.ReadString('WindowPosition','UseAlpha','0')='0' then
        CheckBox1.Checked:=False
      else
        CheckBox1.Checked:=True;
      if inif.ReadString('WindowPosition','StartMinimazed','0')='0' then
        Minimazed.Checked:=False
      else
        Minimazed.Checked:=True;
      TrackBar1.Position:=strtoint(inif.ReadString('WindowPosition','Alpha','255'));
      ShellTreeView1.Path:='C:\';
      ShellTreeView1.Path:=inif.ReadString('FileName','Path',ExtractFilePath(Application.ExeName));

      Mask.Text:=inif.ReadString('Masks','Last','scr_###.jpg');

      Tmp:=TStringList.Create;
      Tmp.Clear;
      inif.ReadSection('Masks',Tmp);
      for i:=0 to Tmp.Count-1 do
        if Copy(Tmp.Strings[i],1,4)='Mask' then
          Mask.Items.Add(inif.ReadString('Masks',Tmp.Strings[i],'###.jpg'));
      Tmp.Destroy;

      SpinEdit1.Text:=inif.ReadString('FileName','Count','0');
      ComboBox1.ItemIndex:=strtoint(inif.ReadString('Format','Type','0'));
      ScrollBar1.Position:=strtoint(inif.ReadString('Format','JPEG_Quality','80'));
      if inif.ReadString('ShootSettings','UseDelay','0')='0' then
        DelayedShoot.Checked:=False
      else
        DelayedShoot.Checked:=True;
      if inif.ReadString('ShootSettings','CaptureCursor','0')='0' then
        CaptureCursor.Checked:=False
      else
        CaptureCursor.Checked:=True;
      Edit2.Text:=inif.ReadString('ShootSettings','Delay','0');
      Edit4.Text:=inif.ReadString('ShootSettings','Timer','0');
      inif.Free;
    end;

   Reg := TRegistry.Create;
   with Reg do
   begin
     RootKey := HKEY_CURRENT_USER;
     OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
     if ValueExists('SCapture') then AutoRun.Checked:=True
       else AutoRun.Checked:=False;
     CloseKey;
     Free;
   end;

  if ComboBox1.Items[ComboBox1.ItemIndex]='JPG' then
    GroupBox3.Visible:=True
  else
    GroupBox3.Visible:=False;
end;

procedure TMainForm.ShootScreen;
var
  DC: HDC;
  Scr: TCanvas;
  BitImg: TBitmap;
  jpgImg: TJPEGImage;
  R:TRect;
  Curs: TIcon;
  CursorInfo: TCursorInfo;
  IconInfo: TIconInfo;
begin
  Scr:=TCanvas.Create;
  BitImg:=TBitmap.Create;
  DC:=GetDC(0);
  try
    Scr.Handle:=DC;
    with Screen do
      begin
        R:=Rect(0, 0, Width, Height);
        BitImg.Width:=Width;
        BitImg.Height:=Height;
        BitImg.Canvas.CopyRect(R, Scr, R);

        if CaptureCursor.Checked then
          begin
            Curs := TIcon.Create;
            try
              CursorInfo := GetCursorInf;
              if CursorInfo.hCursor <> 0 then
                begin
                  Curs.Handle := CursorInfo.hCursor;
                  GetIconInfo(CursorInfo.hCursor, IconInfo);
                  BitImg.Canvas.Draw(CursorInfo.ptScreenPos.X - IconInfo.xHotspot,
                            CursorInfo.ptScreenPos.Y - IconInfo.yHotspot, Curs);
                end;
            finally
              Curs.ReleaseHandle;
              Curs.Free;
            end;
          end;

        if ComboBox1.Items[ComboBox1.ItemIndex]='BMP' then
          BitImg.SaveToFile(FNBM)
        else
        if ComboBox1.Items[ComboBox1.ItemIndex]='JPG' then
          begin
            jpgImg:=TJPEGImage.Create;
            jpgImg.Assign(BitImg);
            jpgImg.CompressionQuality:=ScrollBar1.Position;
            jpgImg.SaveToFile(FNBM);
            jpgImg.Free;
          end
        else
          WriteTiffToFile(FNBM,BitImg);
      end
  finally
    SpinEdit1.Value:=SpinEdit1.Value+1;
    ReleaseDC(0, DC);
    BitImg.Free;
    Scr.Free
  end;
end;

procedure TMainForm.ShootWindow;
var
  DC: HDC;
  HW: HWND;
  Scr: TCanvas;
  BitImg: TBitmap;
  jpgImg: TJPEGImage;
  R:TRect;
  Curs: TIcon;
  CursorInfo: TCursorInfo;
  IconInfo: TIconInfo;
begin
  Scr:=TCanvas.Create;
  BitImg:=TBitmap.Create;
//  if DelayedShoot.Checked then Delay(StrToInt(Edit2.text)*1000);
  HW:=GetForeGroundWindow;
  if not IsWindow(HW) then exit;
  DC:=GetWindowDC(HW);
  try
    Scr.Handle:=DC;
    GetWindowRect(HW,R);
    BitImg.Width:=R.Right - R.Left;
    BitImg.Height:=R.Bottom - R.Top;
    R:=Rect(0,0,BitImg.Width,BitImg.Height);
    BitImg.Canvas.CopyRect(R, Scr, R);

    if CaptureCursor.Checked then
      begin
        Curs := TIcon.Create;
        try
          CursorInfo := GetCursorInf;
          if CursorInfo.hCursor <> 0 then
            begin
              Curs.Handle := CursorInfo.hCursor;
              GetIconInfo(CursorInfo.hCursor, IconInfo);
              BitImg.Canvas.Draw(CursorInfo.ptScreenPos.X - IconInfo.xHotspot,
                        CursorInfo.ptScreenPos.Y - IconInfo.yHotspot, Curs);
            end;
        finally
          Curs.ReleaseHandle;
          Curs.Free;
        end;
      end;

    if ComboBox1.Items[ComboBox1.ItemIndex]='BMP' then
      BitImg.SaveToFile(FNBM)
    else
    if ComboBox1.Items[ComboBox1.ItemIndex]='JPG' then
      begin
        jpgImg:=TJPEGImage.Create;
        jpgImg.Assign(BitImg);
        jpgImg.CompressionQuality:=ScrollBar1.Position;
        jpgImg.SaveToFile(FNBM);
        jpgImg.Free;
      end
    else
      WriteTiffToFile(FNBM,BitImg);
  finally
    SpinEdit1.Value:=SpinEdit1.Value+1;
    ReleaseDC(HW, DC);
    BitImg.Free;
    Scr.Free
  end
end;

procedure TMainForm.TimeredCapture;
begin

if Edit4.Text='' then Edit4.Text:='10';
if StrToInt(Edit4.Text)<10 then Edit4.Text:='10';

TimerCapture:=not TimerCapture;
if TimerCapture then Button6.Caption:='!'
  else Button6.Caption:='  ';

if Edit2.text='' then Edit2.text:='0';
if DelayedShoot.Checked and TimerCapture then
  Delay(StrToInt(Edit2.text)*1000);

while TimerCapture do
  begin
    ShootScreen;
    Delay(StrToInt(Edit4.Text));
  end;
end;

function TMainForm.GetCursorInf: TCursorInfo;
var
  HW:HWND;
  P:TPoint;
  ThreadID, CurrentThreadID: DWORD;
begin
  Result.hCursor := 0;
  ZeroMemory(@Result, SizeOf(Result));
  if GetCursorPos(P) then
    begin
      Result.ptScreenPos := P;
      HW := WindowFromPoint(P);
      if IsWindow(HW) then
        begin
         ThreadID := GetWindowThreadProcessId(HW, nil);
         CurrentThreadID := GetCurrentThreadId;
         if (CurrentThreadID <> ThreadID) then
           begin
             if AttachThreadInput(CurrentThreadID, ThreadID, True) then
               begin
                 Result.hCursor := GetCursor;
                 AttachThreadInput(CurrentThreadID, ThreadID, False);
               end;
             end
             else Result.hCursor := GetCursor;
           end;
      end;
end;


procedure TMainForm.FormCreate(Sender: TObject);
var
  NID: TNotifyIconData;
  TI: TIcon;
begin
  hk1:=GlobalAddAtom('PrnScr_shoot_screen');
  RegisterHotkey(Handle, hk1,0, VK_SNAPSHOT);

  hk2:=GlobalAddAtom('ctrl_PrnScr_shoot_window');
  RegisterHotkey(Handle, hk2,MOD_CONTROL, VK_SNAPSHOT);

  hk3:=GlobalAddAtom('shift_PrnScr_shoot_window');
  RegisterHotkey(Handle, hk3,MOD_SHIFT, VK_SNAPSHOT);

  LoadSettings;

  TI:=TIcon.Create;
  TI.Handle:=Application.Icon.Handle;

//  TI.LoadFromFile('trayicon.ico');
  with NID do
  begin
    cbSize:=SizeOf(TNotifyIconData);
    Wnd:=MainForm.Handle;
    uID:=1;
    uFlags:=NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallBackMessage:=WM_NOTIFYTRAYICON;
    hIcon:=TI.Handle;
    szTip:=('SCapture '+vers);
  end;
  Shell_NotifyIcon(NIM_ADD, Addr(NID));
  TI.Destroy;

  MainForm.Caption:='SCapture '+vers;
  TimerCapture:=False;
end;

procedure TMainForm.WMHotkey( var msg: TWMHotkey );
begin
  if msg.hotkey = hk1 then
    begin
      if DelayedShoot.Checked then Delay(StrToInt(Edit2.text)*1000);
      ShootScreen
    end
  else
  if msg.hotkey = hk2 then
    begin
      if DelayedShoot.Checked then Delay(StrToInt(Edit2.text)*1000);
      ShootWindow
    end
  else
  if msg.hotkey = hk3 then
    TimeredCapture;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
  NID: TNotifyIconData;
begin
  UnRegisterHotKey(Handle, hk1);
  GlobalDeleteAtom(hk1);

  UnRegisterHotKey(Handle, hk2);
  GlobalDeleteAtom(hk2);

  UnRegisterHotKey(Handle, hk3);
  GlobalDeleteAtom(hk3);

  SaveSettings;

  with NID do
  begin
    cbSize:=SizeOf(TNotifyIconData);
    Wnd:=MainForm.Handle;
    uID:=1;
  end;
  Shell_NotifyIcon(NIM_DELETE, Addr(NID));
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
Application.Minimize;
ShowWindow(Application.Handle, sw_Hide);
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.ScrollBar1Change(Sender: TObject);
begin
Label2.Caption:=IntToStr(ScrollBar1.Position)+'%';
end;

procedure TMainForm.ComboBox1Change(Sender: TObject);
begin
  if ComboBox1.Items[ComboBox1.ItemIndex]='JPG' then
      GroupBox3.Visible:=True
  else
    GroupBox3.Visible:=False;
//  Edit1.Text:=ChangeFileExt(Edit1.Text,AnsiLowerCase(ComboBox1.Items[ComboBox1.ItemIndex]));
  Mask.Text:=Copy(Mask.Text,1,pos(ExtractFileExt(Mask.Text),Mask.Text)-1)+'.'+AnsiLowerCase(ComboBox1.Items[ComboBox1.ItemIndex]);
end;

procedure TMainForm.ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
begin
Edit3.Text:=ShellTreeView1.Path;
end;

procedure TMainForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if (not (key in ['0'..'9'])) and (not (key=#08)) then key:=#0;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  ShellExecute(0,'open','explorer.exe',Pchar(ShellTreeView1.Path),nil,SW_NORMAL);
end;

procedure TMainForm.Button4Click(Sender: TObject);
begin
  SpinEdit1.Value:=0;
end;

procedure TMainForm.TrackBar1Change(Sender: TObject);
begin
  MainForm.AlphaBlendValue:=TrackBar1.Position;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  if Minimazed.Checked then Application.Minimize;
  ShowWindow(Application.Handle, sw_Hide);
end;

procedure TMainForm.N1Click(Sender: TObject);
begin
  Application.Restore;
  ShowWindow(Application.Handle, sw_Hide);
  SetForegroundWindow(Application.Handle);
end;

procedure TMainForm.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.Button5Click(Sender: TObject);
begin
  AboutBox:=TAboutBox.Create(self);
  AboutBox.Version.Caption:=vers;
  AboutBox.ShowModal;
  AboutBox.Destroy;
end;

procedure TMainForm.Button8Click(Sender: TObject);
begin
  if Edit2.text='' then Edit2.text:='0';
  if DelayedShoot.Checked then Delay(StrToInt(Edit2.text)*1000);
  ShootScreen;
end;

procedure TMainForm.Button7Click(Sender: TObject);
begin
  if Edit2.text='' then Edit2.text:='0';
  if DelayedShoot.Checked then Delay(StrToInt(Edit2.text)*1000);
  ShootWindow;
end;

procedure TMainForm.Button6Click(Sender: TObject);
begin
  TimeredCapture;
end;

procedure TMainForm.CheckBox1Click(Sender: TObject);
begin
  MainForm.AlphaBlend:=CheckBox1.Checked;
end;

procedure TMainForm.Button9Click(Sender: TObject);
begin
  Mask.Items.Add(Mask.Text);
end;

procedure TMainForm.AutoRunClick(Sender: TObject);
var
   Reg: TRegistry;
begin

   Reg := TRegistry.Create;
   with Reg do
   begin
     RootKey := HKEY_CURRENT_USER;
     OpenKey('Software\Microsoft\Windows\CurrentVersion\Run', True);
     if AutoRun.Checked then WriteString('SCapture', Application.ExeName)
       else if ValueExists('SCapture') then DeleteValue('SCapture');
     CloseKey;
     Free;
   end;
end;

end.
